# class Crystal::Macros::RangeLiteral

- Crystal::Macros::RangeLiteral
- Crystal::Macros::ASTNode

##
Overview

A range literal.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #begin : ASTNode

  Similar to `Range#begin`

- #each(&) : Nil

  Similar to `Range#each`

- #end : ASTNode

  Similar to `Range#end`

- #excludes_end? : ASTNode

  Similar to `Range#excludes_end?`

- #map(&) : ArrayLiteral

  Similar to `Enumerable#map` for a `Range`.

- #to_a : ArrayLiteral

  Similar to `Enumerable#to_a` for a `Range`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def begin : ASTNode #

Similar to `Range#begin`

def each(&) : Nil #

Similar to `Range#each`

def end : ASTNode #

Similar to `Range#end`

def excludes_end? : ASTNode #

Similar to `Range#excludes_end?`

def map(&) : ArrayLiteral #

Similar to `Enumerable#map` for a `Range`. Only works on ranges of `NumberLiteral`s considered as integers.

def to_a : ArrayLiteral #

Similar to `Enumerable#to_a` for a `Range`. Only works on ranges of `NumberLiteral`s considered as integers.